#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
#include "WinBase_constants.ch"
#include "WinUser_constants.ch"
#include "appevent.ch"
#pragma Library( "xppui2.lib" )
#include "xbp.ch"
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
proc appsys ; return
//----------------------------------------------------------------------------------------------------------------------
function GetMonitorRects(hm,rcm,rcw)
local mi := __i32(40) + ChrR(0,36)
DEFAULT hm := @user32:MonitorFromWindow(0,1)
@user32:GetMonitorInfoA(hm,@mi)
rcm := PeekDWord(mi, 4,4); rcm[3] -= rcm[1] ; rcm[4] -= rcm[2]
rcw := PeekDWord(mi,20,4); rcw[3] -= rcw[1] ; rcw[4] -= rcw[2]
return { rcw[3] , rcw[4] }
//----------------------------------------------------------------------------------------------------------------------
function rctd2bd(rc,rcp)
rc[1] += rcp[1]
rc[2] := rcp[4] - (rc[2] + rc[4])
return NIL
//----------------------------------------------------------------------------------------------------------------------
function td2bd_y(y,cy,rc) ; return ( PeekDWord(rc,12) - (y + cy) )
//----------------------------------------------------------------------------------------------------------------------
function GenericMsgLoop(evt_exit)
local xbp,p1,p2,evt
xbp := p1 := p2 := evt := NIL
DEFAULT evt_exit := xbeP_Quit
while evt != xbeP_Quit
   evt := AppEvent(@p1,@p2,@xbp)
   xbp:HandleEvent(evt,p1,p2)
end
return NIL
//----------------------------------------------------------------------------------------------------------------------
proc main
local rcm := NIL
local rc := NIL
local dlg,da,nStyle
local n,y
local aSle := Array(50)
local total_height
GetMonitorRects(,@rcm,@rc)
rc[1] += 120 ; rc[2] += 120 ; rc[3] -= 240 ; rc[4] -= 240
rctd2bd(@rc,rcm)
dlg := XbpDialog():New(,,{rc[1],rc[2]} , {rc[3],rc[4]})
da  := dlg:DrawingArea
dlg:ClipChildren := .T.
da:ClipChildren   := .T.
dlg:title := "Test"
dlg:TaskList := .T.
dlg:close := {|| PostAppEvent(xbeP_Quit,,,dlg) }
dlg:create()
                              
// As we need to know the panel height we calculate it before
// 50 controls of height = 20 + separation = 5 + top and bottom margin = 5
total_height := (25 * 50) + 10

// This is the only we need to manage the scroll
// ot4xb_automatic_scroll_focus( container , panel, panel height, size of virtual row , disable wheel handling )
// virtual row size is 20 by default
// disable wheel handling .F. by default 
// tis latest param is to magage the wheel manually by default our function manage the wheel automatically

ot4xb_automatic_scroll_focus(dlg,da,total_height,25 )
y := 5
@user32:GetClientRect(da:GetHWnd(),@rc)
for n := 1 to 50
   WITH OBJECT XbpStatic():New(da,da,{10,td2bd_y(y,20,rc)}, { 50 , 20 } ,, .T. )
      .:caption := cPrintf("%i: ",n)
      .:options := nOr( XBPSTATIC_TEXT_RIGHT , XBPSTATIC_TEXT_VCENTER )
      .:Create()
   END WITH
   WITH OBJECT aSle[n] := XbpSle():New(da,da,{70 ,td2bd_y(y,20,rc)}, { rc[3] - 75 , 20 } ,, .T. )
      .:TabStop := .T.
      .:Create()
   END WITH
   y += 25
next
dlg:show()
// give focus to #40 and it scrool by itself
SetAppFocus(aSle[40] )
GenericMsgLoop()
return
//-----------------------------------------------------------------------------------------------------